// FullAccess
resource "azurerm_role_definition" "azure_devtest_labs_fullaccess_definition" {
  name              = "azure-devtest-labs-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DevTestLab/register/action",
      "Microsoft.DevTestLab/labs/policySets/read",
      "Microsoft.DevTestLab/labs/policySets/EvaluatePolicies/action",
      "Microsoft.DevTestLab/labs/delete",
      "Microsoft.DevTestLab/labs/read",
      "Microsoft.DevTestLab/labs/write",
      "Microsoft.DevTestLab/labs/ListVhds/action",
      "Microsoft.DevTestLab/labs/GenerateUploadUri/action",
      "Microsoft.DevTestLab/labs/CreateEnvironment/action",
      "Microsoft.DevTestLab/labs/ClaimAnyVm/action",
      "Microsoft.DevTestLab/labs/ExportResourceUsage/action",
      "Microsoft.DevTestLab/labs/ImportVirtualMachine/action",
      "Microsoft.DevTestLab/labs/EnsureCurrentUserProfile/action",
      "Microsoft.DevTestLab/labs/policySets/policies/delete",
      "Microsoft.DevTestLab/labs/policySets/policies/read",
      "Microsoft.DevTestLab/labs/policySets/policies/write",
      "Microsoft.DevTestLab/labs/schedules/delete",
      "Microsoft.DevTestLab/labs/schedules/read",
      "Microsoft.DevTestLab/labs/schedules/write",
      "Microsoft.DevTestLab/labs/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/schedules/ListApplicable/action",
      "Microsoft.DevTestLab/schedules/delete",
      "Microsoft.DevTestLab/schedules/read",
      "Microsoft.DevTestLab/schedules/write",
      "Microsoft.DevTestLab/schedules/Execute/action",
      "Microsoft.DevTestLab/schedules/Retarget/action",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/read",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/write",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/artifactSources/delete",
      "Microsoft.DevTestLab/labs/artifactSources/read",
      "Microsoft.DevTestLab/labs/artifactSources/write",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/read",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/GenerateArmTemplate/action",
      "Microsoft.DevTestLab/labs/galleryImages/read",
      "Microsoft.DevTestLab/labs/customImages/delete",
      "Microsoft.DevTestLab/labs/customImages/read",
      "Microsoft.DevTestLab/labs/customImages/write",
      "Microsoft.DevTestLab/labs/virtualNetworks/delete",
      "Microsoft.DevTestLab/labs/virtualNetworks/read",
      "Microsoft.DevTestLab/labs/virtualNetworks/write",
      "Microsoft.DevTestLab/labs/virtualMachines/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/read",
      "Microsoft.DevTestLab/labs/virtualMachines/write",
      "Microsoft.DevTestLab/labs/virtualMachines/Start/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Stop/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Restart/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Redeploy/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Resize/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ApplyArtifacts/action",
      "Microsoft.DevTestLab/labs/virtualMachines/AddDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/DetachDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Claim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/UnClaim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/TransferDisks/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labs/virtualMachines/GetRdpFileContents/action",
      "Microsoft.DevTestLab/labs/formulas/delete",
      "Microsoft.DevTestLab/labs/formulas/read",
      "Microsoft.DevTestLab/labs/formulas/write",
      "Microsoft.DevTestLab/labs/costs/read",
      "Microsoft.DevTestLab/labs/costs/write",
      "Microsoft.DevTestLab/labs/users/disks/delete",
      "Microsoft.DevTestLab/labs/users/disks/read",
      "Microsoft.DevTestLab/labs/users/disks/write",
      "Microsoft.DevTestLab/labs/users/disks/Attach/action",
      "Microsoft.DevTestLab/labs/users/disks/Detach/action",
      "Microsoft.DevTestLab/labs/users/delete",
      "Microsoft.DevTestLab/labs/users/read",
      "Microsoft.DevTestLab/labs/users/write",
      "Microsoft.DevTestLab/labs/notificationChannels/delete",
      "Microsoft.DevTestLab/labs/notificationChannels/read",
      "Microsoft.DevTestLab/labs/notificationChannels/write",
      "Microsoft.DevTestLab/labs/notificationChannels/Notify/action",
      "Microsoft.DevTestLab/labs/users/secrets/delete",
      "Microsoft.DevTestLab/labs/users/secrets/read",
      "Microsoft.DevTestLab/labs/users/secrets/write",
      "Microsoft.DevTestLab/locations/operations/read",
      "Microsoft.DevTestLab/labs/artifactSources/armTemplates/read",
      "Microsoft.DevTestLab/labs/users/environments/delete",
      "Microsoft.DevTestLab/labs/users/environments/read",
      "Microsoft.DevTestLab/labs/users/environments/write",
      "Microsoft.DevTestLab/labs/serviceRunners/delete",
      "Microsoft.DevTestLab/labs/serviceRunners/read",
      "Microsoft.DevTestLab/labs/serviceRunners/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Start/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Stop/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labCenters/delete",
      "Microsoft.DevTestLab/labCenters/read",
      "Microsoft.DevTestLab/labCenters/write",
      "Microsoft.DevTestLab/labs/vmPools/delete",
      "Microsoft.DevTestLab/labs/vmPools/read",
      "Microsoft.DevTestLab/labs/vmPools/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/write",
      "Microsoft.DevTestLab/labs/idleShutdowns/delete",
      "Microsoft.DevTestLab/labs/idleShutdowns/read",
      "Microsoft.DevTestLab/labs/idleShutdowns/write",
      "Microsoft.DevSpaces/register/action",
      "Microsoft.DevSpaces/controllers/read",
      "Microsoft.DevSpaces/controllers/write",
      "Microsoft.DevSpaces/controllers/delete",
      "Microsoft.DevSpaces/controllers/listConnectionDetails/action",
      "Microsoft.DevSpaces/locations/operationresults/read",
      "Microsoft.DevSpaces/locations/checkContainerHostMapping/action",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_devtest_labs_readonly_definition" {
  name              = "azure-devtest-labs-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DevTestLab/labs/policySets/read",
      "Microsoft.DevTestLab/labs/read",
      "Microsoft.DevTestLab/labs/policySets/policies/read",
      "Microsoft.DevTestLab/labs/schedules/read",
      "Microsoft.DevTestLab/schedules/read",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/read",
      "Microsoft.DevTestLab/labs/artifactSources/read",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/read",
      "Microsoft.DevTestLab/labs/galleryImages/read",
      "Microsoft.DevTestLab/labs/customImages/read",
      "Microsoft.DevTestLab/labs/virtualNetworks/read",
      "Microsoft.DevTestLab/labs/virtualMachines/read",
      "Microsoft.DevTestLab/labs/formulas/read",
      "Microsoft.DevTestLab/labs/costs/read",
      "Microsoft.DevTestLab/labs/users/disks/read",
      "Microsoft.DevTestLab/labs/users/read",
      "Microsoft.DevTestLab/labs/notificationChannels/read",
      "Microsoft.DevTestLab/labs/users/secrets/read",
      "Microsoft.DevTestLab/locations/operations/read",
      "Microsoft.DevTestLab/labs/artifactSources/armTemplates/read",
      "Microsoft.DevTestLab/labs/users/environments/read",
      "Microsoft.DevTestLab/labs/serviceRunners/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/read",
      "Microsoft.DevTestLab/labCenters/read",
      "Microsoft.DevTestLab/labs/vmPools/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/read",
      "Microsoft.DevTestLab/labs/idleShutdowns/read",
      "Microsoft.DevSpaces/controllers/read",
      "Microsoft.DevSpaces/locations/operationresults/read",
    ]

    not_actions = [
      "Microsoft.DevTestLab/register/action",
      "Microsoft.DevTestLab/labs/policySets/EvaluatePolicies/action",
      "Microsoft.DevTestLab/labs/delete",
      "Microsoft.DevTestLab/labs/write",
      "Microsoft.DevTestLab/labs/ListVhds/action",
      "Microsoft.DevTestLab/labs/GenerateUploadUri/action",
      "Microsoft.DevTestLab/labs/CreateEnvironment/action",
      "Microsoft.DevTestLab/labs/ClaimAnyVm/action",
      "Microsoft.DevTestLab/labs/ExportResourceUsage/action",
      "Microsoft.DevTestLab/labs/ImportVirtualMachine/action",
      "Microsoft.DevTestLab/labs/EnsureCurrentUserProfile/action",
      "Microsoft.DevTestLab/labs/policySets/policies/delete",
      "Microsoft.DevTestLab/labs/policySets/policies/write",
      "Microsoft.DevTestLab/labs/schedules/delete",
      "Microsoft.DevTestLab/labs/schedules/write",
      "Microsoft.DevTestLab/labs/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/schedules/ListApplicable/action",
      "Microsoft.DevTestLab/schedules/delete",
      "Microsoft.DevTestLab/schedules/write",
      "Microsoft.DevTestLab/schedules/Execute/action",
      "Microsoft.DevTestLab/schedules/Retarget/action",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/write",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/artifactSources/delete",
      "Microsoft.DevTestLab/labs/artifactSources/write",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/GenerateArmTemplate/action",
      "Microsoft.DevTestLab/labs/customImages/delete",
      "Microsoft.DevTestLab/labs/customImages/write",
      "Microsoft.DevTestLab/labs/virtualNetworks/delete",
      "Microsoft.DevTestLab/labs/virtualNetworks/write",
      "Microsoft.DevTestLab/labs/virtualMachines/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/write",
      "Microsoft.DevTestLab/labs/virtualMachines/Start/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Stop/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Restart/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Redeploy/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Resize/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ApplyArtifacts/action",
      "Microsoft.DevTestLab/labs/virtualMachines/AddDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/DetachDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Claim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/UnClaim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/TransferDisks/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labs/virtualMachines/GetRdpFileContents/action",
      "Microsoft.DevTestLab/labs/formulas/delete",
      "Microsoft.DevTestLab/labs/formulas/write",
      "Microsoft.DevTestLab/labs/costs/write",
      "Microsoft.DevTestLab/labs/users/disks/delete",
      "Microsoft.DevTestLab/labs/users/disks/write",
      "Microsoft.DevTestLab/labs/users/disks/Attach/action",
      "Microsoft.DevTestLab/labs/users/disks/Detach/action",
      "Microsoft.DevTestLab/labs/users/delete",
      "Microsoft.DevTestLab/labs/users/write",
      "Microsoft.DevTestLab/labs/notificationChannels/delete",
      "Microsoft.DevTestLab/labs/notificationChannels/write",
      "Microsoft.DevTestLab/labs/notificationChannels/Notify/action",
      "Microsoft.DevTestLab/labs/users/secrets/delete",
      "Microsoft.DevTestLab/labs/users/secrets/write",
      "Microsoft.DevTestLab/labs/users/environments/delete",
      "Microsoft.DevTestLab/labs/users/environments/write",
      "Microsoft.DevTestLab/labs/serviceRunners/delete",
      "Microsoft.DevTestLab/labs/serviceRunners/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Start/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Stop/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labCenters/delete",
      "Microsoft.DevTestLab/labCenters/write",
      "Microsoft.DevTestLab/labs/vmPools/delete",
      "Microsoft.DevTestLab/labs/vmPools/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/write",
      "Microsoft.DevTestLab/labs/idleShutdowns/delete",
      "Microsoft.DevTestLab/labs/idleShutdowns/write",
      "Microsoft.DevSpaces/register/action",
      "Microsoft.DevSpaces/controllers/write",
      "Microsoft.DevSpaces/controllers/delete",
      "Microsoft.DevSpaces/controllers/listConnectionDetails/action",
      "Microsoft.DevSpaces/locations/checkContainerHostMapping/action",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_devtest_labs_noaccess_definition" {
  name              = "azure-devtest-labs-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.DevTestLab/register/action",
      "Microsoft.DevTestLab/labs/policySets/read",
      "Microsoft.DevTestLab/labs/policySets/EvaluatePolicies/action",
      "Microsoft.DevTestLab/labs/delete",
      "Microsoft.DevTestLab/labs/read",
      "Microsoft.DevTestLab/labs/write",
      "Microsoft.DevTestLab/labs/ListVhds/action",
      "Microsoft.DevTestLab/labs/GenerateUploadUri/action",
      "Microsoft.DevTestLab/labs/CreateEnvironment/action",
      "Microsoft.DevTestLab/labs/ClaimAnyVm/action",
      "Microsoft.DevTestLab/labs/ExportResourceUsage/action",
      "Microsoft.DevTestLab/labs/ImportVirtualMachine/action",
      "Microsoft.DevTestLab/labs/EnsureCurrentUserProfile/action",
      "Microsoft.DevTestLab/labs/policySets/policies/delete",
      "Microsoft.DevTestLab/labs/policySets/policies/read",
      "Microsoft.DevTestLab/labs/policySets/policies/write",
      "Microsoft.DevTestLab/labs/schedules/delete",
      "Microsoft.DevTestLab/labs/schedules/read",
      "Microsoft.DevTestLab/labs/schedules/write",
      "Microsoft.DevTestLab/labs/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/schedules/ListApplicable/action",
      "Microsoft.DevTestLab/schedules/delete",
      "Microsoft.DevTestLab/schedules/read",
      "Microsoft.DevTestLab/schedules/write",
      "Microsoft.DevTestLab/schedules/Execute/action",
      "Microsoft.DevTestLab/schedules/Retarget/action",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/read",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/write",
      "Microsoft.DevTestLab/labs/virtualMachines/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/schedules/Execute/action",
      "Microsoft.DevTestLab/labs/artifactSources/delete",
      "Microsoft.DevTestLab/labs/artifactSources/read",
      "Microsoft.DevTestLab/labs/artifactSources/write",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/read",
      "Microsoft.DevTestLab/labs/artifactSources/artifacts/GenerateArmTemplate/action",
      "Microsoft.DevTestLab/labs/galleryImages/read",
      "Microsoft.DevTestLab/labs/customImages/delete",
      "Microsoft.DevTestLab/labs/customImages/read",
      "Microsoft.DevTestLab/labs/customImages/write",
      "Microsoft.DevTestLab/labs/virtualNetworks/delete",
      "Microsoft.DevTestLab/labs/virtualNetworks/read",
      "Microsoft.DevTestLab/labs/virtualNetworks/write",
      "Microsoft.DevTestLab/labs/virtualMachines/delete",
      "Microsoft.DevTestLab/labs/virtualMachines/read",
      "Microsoft.DevTestLab/labs/virtualMachines/write",
      "Microsoft.DevTestLab/labs/virtualMachines/Start/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Stop/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Restart/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Redeploy/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Resize/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ApplyArtifacts/action",
      "Microsoft.DevTestLab/labs/virtualMachines/AddDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/DetachDataDisk/action",
      "Microsoft.DevTestLab/labs/virtualMachines/Claim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/UnClaim/action",
      "Microsoft.DevTestLab/labs/virtualMachines/TransferDisks/action",
      "Microsoft.DevTestLab/labs/virtualMachines/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labs/virtualMachines/GetRdpFileContents/action",
      "Microsoft.DevTestLab/labs/formulas/delete",
      "Microsoft.DevTestLab/labs/formulas/read",
      "Microsoft.DevTestLab/labs/formulas/write",
      "Microsoft.DevTestLab/labs/costs/read",
      "Microsoft.DevTestLab/labs/costs/write",
      "Microsoft.DevTestLab/labs/users/disks/delete",
      "Microsoft.DevTestLab/labs/users/disks/read",
      "Microsoft.DevTestLab/labs/users/disks/write",
      "Microsoft.DevTestLab/labs/users/disks/Attach/action",
      "Microsoft.DevTestLab/labs/users/disks/Detach/action",
      "Microsoft.DevTestLab/labs/users/delete",
      "Microsoft.DevTestLab/labs/users/read",
      "Microsoft.DevTestLab/labs/users/write",
      "Microsoft.DevTestLab/labs/notificationChannels/delete",
      "Microsoft.DevTestLab/labs/notificationChannels/read",
      "Microsoft.DevTestLab/labs/notificationChannels/write",
      "Microsoft.DevTestLab/labs/notificationChannels/Notify/action",
      "Microsoft.DevTestLab/labs/users/secrets/delete",
      "Microsoft.DevTestLab/labs/users/secrets/read",
      "Microsoft.DevTestLab/labs/users/secrets/write",
      "Microsoft.DevTestLab/locations/operations/read",
      "Microsoft.DevTestLab/labs/artifactSources/armTemplates/read",
      "Microsoft.DevTestLab/labs/users/environments/delete",
      "Microsoft.DevTestLab/labs/users/environments/read",
      "Microsoft.DevTestLab/labs/users/environments/write",
      "Microsoft.DevTestLab/labs/serviceRunners/delete",
      "Microsoft.DevTestLab/labs/serviceRunners/read",
      "Microsoft.DevTestLab/labs/serviceRunners/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/delete",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/read",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/write",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Start/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/Stop/action",
      "Microsoft.DevTestLab/labs/users/serviceFabrics/ListApplicableSchedules/action",
      "Microsoft.DevTestLab/labCenters/delete",
      "Microsoft.DevTestLab/labCenters/read",
      "Microsoft.DevTestLab/labCenters/write",
      "Microsoft.DevTestLab/labs/vmPools/delete",
      "Microsoft.DevTestLab/labs/vmPools/read",
      "Microsoft.DevTestLab/labs/vmPools/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/write",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/delete",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/read",
      "Microsoft.DevTestLab/labs/sharedGalleries/sharedImages/write",
      "Microsoft.DevTestLab/labs/idleShutdowns/delete",
      "Microsoft.DevTestLab/labs/idleShutdowns/read",
      "Microsoft.DevTestLab/labs/idleShutdowns/write",
      "Microsoft.DevSpaces/register/action",
      "Microsoft.DevSpaces/controllers/read",
      "Microsoft.DevSpaces/controllers/write",
      "Microsoft.DevSpaces/controllers/delete",
      "Microsoft.DevSpaces/controllers/listConnectionDetails/action",
      "Microsoft.DevSpaces/locations/operationresults/read",
      "Microsoft.DevSpaces/locations/checkContainerHostMapping/action",
    ]
  }
}
